<?php
/*
Plugin Name: NND Facebook Gravatar Grabber
Plugin URI: http://nnd.bostonsuperblog.com/2010/10/30/wordpress-plug-in-nerd-next-doors-facebook-gravatar-grabber/
Description: If a user or commenter's URL is their Facebook profile this plugin will grab their Profile Picture for use as their Gravatar!
Version: 1.0
Author: Dan Jones
Author URI: http://nnd.BostonSuperBlog.com
License: GPL2
*/

/*  Copyright YEAR  PLUGIN_AUTHOR_NAME  (email : PLUGIN AUTHOR EMAIL)

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License, version 2, as 
    published by the Free Software Foundation.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

if ( !function_exists( 'get_avatar' ) ) :
function get_avatar( $id_or_email, $size = '96', $default = '', $alt = false ) {
	if ( ! get_option('show_avatars') )
		return false;

	if ( false === $alt)
		$safe_alt = '';
	else
		$safe_alt = esc_attr( $alt );

	if ( !is_numeric($size) )
		$size = '96';

	$email = '';
	if ( is_numeric($id_or_email) ) {
		$id = (int) $id_or_email;
		$user = get_userdata($id);
		if ( $user )
			$email = $user->user_email;
	} elseif ( is_object($id_or_email) ) {
		// No avatar for pingbacks or trackbacks
		$allowed_comment_types = apply_filters( 'get_avatar_comment_types', array( 'comment' ) );
		if ( ! empty( $id_or_email->comment_type ) && ! in_array( $id_or_email->comment_type, (array) $allowed_comment_types ) )
			return false;

		if ( !empty($id_or_email->user_id) ) {
			$id = (int) $id_or_email->user_id;
			$user = get_userdata($id);
			if ( $user)
				$email = $user->user_email;
		} elseif ( !empty($id_or_email->comment_author_email) ) {
			$email = $id_or_email->comment_author_email;
		}
	} else {
		$email = $id_or_email;
	}

	if ( empty($default) ) {
		$avatar_default = get_option('avatar_default');
		if ( empty($avatar_default) )
			$default = 'mystery';
		else
			$default = $avatar_default;
	}
/* IF THER USER / COMMENTER HAS FACEBOOK IN THEIR URL GO GRAB THEIR PROFILE PICTURE */
// CHECK FOR A COMMENTER WHOSE URL IS FACEBOOK
if(preg_match("/facebook/i",$email)){
		$author_url =  $id_or_email->comment_author_url;
        $parse_author_url = (parse_url($author_url));
        $parse_author_url_q = $parse_author_url['query'];
            if(preg_match('/id[=]([0-9]*)/', $parse_author_url_q, $match)){
                $fb_id = "/".$match[1];}
            else{ $fb_id = $parse_author_url['path'];
            }
        $out = "http://graph.facebook.com".$fb_id."/picture?type=square";
		$avatar = "<img alt='{$safe_alt}' src='{$out}' class='avatar avatar-{$size} photo' height='{$size}' width='{$size}' />";
        }
//CHECK FOR A USER OR COMMENTER WHOSE URL IS FACEBOOK [NOTE: I'm not sure if this does anything that the other 2 don't cover]
else if (preg_match("/facebook/i",$id_or_email->comment_author_url)) {
		$author_url =  $id_or_email->comment_author_url;
        $parse_author_url = (parse_url($author_url));
        $parse_author_url_q = $parse_author_url['query'];
            if(preg_match('/id[=]([0-9]*)/', $parse_author_url_q, $match)){
                $fb_id = "/".$match[1];}
            else{ $fb_id = $parse_author_url['path'];
            }
        $out = "http://graph.facebook.com".$fb_id."/picture?type=square";
		$avatar = "<img alt='{$safe_alt}' src='{$out}' class='avatar avatar-{$size} photo' height='{$size}' width='{$size}' />";
        }
//CHECK THE USER'S URL FOR FACEBOOK
else if ( preg_match("/facebook/i",$user->user_url)) {
		$author_url =  $user->user_url;
        $parse_author_url = (parse_url($author_url));
        $parse_author_url_q = $parse_author_url['query'];
            if(preg_match('/id[=]([0-9]*)/', $parse_author_url_q, $match)){
                $fb_id = "/".$match[1];}
            else{ $fb_id = $parse_author_url['path'];
            }
        $out = "http://graph.facebook.com".$fb_id."/picture?type=square";
		$avatar = "<img alt='{$safe_alt}' src='{$out}' class='avatar avatar-{$size} photo' height='{$size}' width='{$size}' />";
        }
else{
	if ( !empty($email) )
		$email_hash = md5( strtolower( $email ) );

	if ( is_ssl() ) {
		$host = 'https://secure.gravatar.com';
	} else {
		if ( !empty($email) )
			$host = sprintf( "http://%d.gravatar.com", ( hexdec( $email_hash{0} ) % 2 ) );
		else
			$host = 'http://0.gravatar.com';
	}

	if ( 'mystery' == $default )
		$default = "$host/avatar/ad516503a11cd5ca435acc9bb6523536?s={$size}"; // ad516503a11cd5ca435acc9bb6523536 == md5('unknown@gravatar.com')
	elseif ( 'blank' == $default )
		$default = includes_url('images/blank.gif');
	elseif ( !empty($email) && 'gravatar_default' == $default )
		$default = '';
	elseif ( 'gravatar_default' == $default )
		$default = "$host/avatar/s={$size}";
	elseif ( empty($email) )
		$default = "$host/avatar/?d=$default&amp;s={$size}";
	elseif ( strpos($default, 'http://') === 0 )
		$default = add_query_arg( 's', $size, $default );

	if ( !empty($email) ) {
		$out = "$host/avatar/";
		$out .= $email_hash;
		$out .= '?s='.$size;
		$out .= '&amp;d=' . urlencode( $default );

		$rating = get_option('avatar_rating');
		if ( !empty( $rating ) )
			$out .= "&amp;r={$rating}";

		$avatar = "<img alt='{$safe_alt}' src='{$out}' class='avatar avatar-{$size} photo' height='{$size}' width='{$size}' />";
	} else {
		$avatar = "<img alt='{$safe_alt}' src='{$default}' class='avatar avatar-{$size} photo avatar-default' height='{$size}' width='{$size}' />";
	}
}
	return apply_filters('get_avatar', $avatar, $id_or_email, $size, $default, $alt);
}
endif;
?>